diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/mgt-headers.h ns-3.35/src/wifi/model/mgt-headers.h
--- ns-3.34/src/wifi/model/mgt-headers.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/mgt-headers.h	2021-10-01 13:26:48.000000000 -0700
@@ -38,6 +38,7 @@
 #include "edca-parameter-set.h"
 #include "ns3/he-capabilities.h"
 #include "ns3/he-operation.h"
+#include "ns3/mu-edca-parameter-set.h"
 
 namespace ns3 {
 
@@ -400,6 +401,12 @@
    */
   EdcaParameterSet GetEdcaParameterSet (void) const;
   /**
+   * Return the MU EDCA Parameter Set.
+   *
+   * \return the MU EDCA Parameter Set
+   */
+  MuEdcaParameterSet GetMuEdcaParameterSet (void) const;
+  /**
    * Set the Capability information.
    *
    * \param capabilities Capability information
@@ -466,6 +473,12 @@
    */
   void SetEdcaParameterSet (EdcaParameterSet edcaParameterSet);
   /**
+   * Set the MU EDCA Parameter Set.
+   *
+   * \param muEdcaParameterSet the MU EDCA Parameter Set
+   */
+  void SetMuEdcaParameterSet (MuEdcaParameterSet muEdcaParameterSet);
+  /**
    * Set the HE capabilities.
    *
    * \param heCapabilities HE capabilities
@@ -504,6 +517,7 @@
   EdcaParameterSet m_edcaParameterSet; //!< EDCA Parameter Set
   HeCapabilities m_heCapability; //!< HE capabilities
   HeOperation m_heOperation; //!< HE operation
+  MuEdcaParameterSet m_muEdcaParameterSet; //!< MU EDCA Parameter Set
 };
 
 
@@ -706,6 +720,12 @@
    */
   EdcaParameterSet GetEdcaParameterSet (void) const;
   /**
+   * Return the MU EDCA Parameter Set.
+   *
+   * \return the MU EDCA Parameter Set
+   */
+  MuEdcaParameterSet GetMuEdcaParameterSet (void) const;
+  /**
    * Set the Capability information.
    *
    * \param capabilities Capability information
@@ -790,6 +810,12 @@
    */
   void SetEdcaParameterSet (EdcaParameterSet edcaParameterSet);
   /**
+   * Set the MU EDCA Parameter Set.
+   *
+   * \param muEdcaParameterSet the MU EDCA Parameter Set
+   */
+  void SetMuEdcaParameterSet (MuEdcaParameterSet muEdcaParameterSet);
+  /**
    * Return the time stamp.
    *
    * \return time stamp
@@ -824,6 +850,7 @@
   HeOperation m_heOperation;         //!< HE operation
   ErpInformation m_erpInformation;     //!< ERP information
   EdcaParameterSet m_edcaParameterSet; //!< EDCA Parameter Set
+  MuEdcaParameterSet m_muEdcaParameterSet; //!< MU EDCA Parameter Set
 };
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/mpdu-aggregator.cc ns-3.35/src/wifi/model/mpdu-aggregator.cc
--- ns-3.34/src/wifi/model/mpdu-aggregator.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/mpdu-aggregator.cc	2021-10-01 13:26:48.000000000 -0700
@@ -126,28 +126,7 @@
   AcIndex ac = QosUtilsMapTidToAc (tid);
 
   // Find the A-MPDU max size configured on this device
-  UintegerValue size;
-
-  switch (ac)
-    {
-      case AC_BE:
-        m_mac->GetAttribute ("BE_MaxAmpduSize", size);
-        break;
-      case AC_BK:
-        m_mac->GetAttribute ("BK_MaxAmpduSize", size);
-        break;
-      case AC_VI:
-        m_mac->GetAttribute ("VI_MaxAmpduSize", size);
-        break;
-      case AC_VO:
-        m_mac->GetAttribute ("VO_MaxAmpduSize", size);
-        break;
-      default:
-        NS_ABORT_MSG ("Unknown AC " << ac);
-        return 0;
-    }
-
-  uint32_t maxAmpduSize = size.Get ();
+  uint32_t maxAmpduSize = m_mac->GetMaxAmpduSize (ac);
 
   if (maxAmpduSize == 0)
     {
@@ -213,7 +192,7 @@
 
 std::vector<Ptr<WifiMacQueueItem>>
 MpduAggregator::GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu, WifiTxParameters& txParams,
-                              Time availableTime, WifiMacQueueItem::QueueIteratorPair queueIt) const
+                              Time availableTime, WifiMacQueueItem::ConstIterator queueIt) const
 {
   NS_LOG_FUNCTION (this << *mpdu << &txParams << availableTime);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/mpdu-aggregator.h ns-3.35/src/wifi/model/mpdu-aggregator.h
--- ns-3.34/src/wifi/model/mpdu-aggregator.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/mpdu-aggregator.h	2021-10-01 13:26:48.000000000 -0700
@@ -125,7 +125,7 @@
   std::vector<Ptr<WifiMacQueueItem>> GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu,
                                                    WifiTxParameters& txParams,
                                                    Time availableTime,
-                                                   WifiMacQueueItem::QueueIteratorPair queueIt) const;
+                                                   WifiMacQueueItem::ConstIterator queueIt) const;
 
   /**
    * Set the MAC layer to use.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/msdu-aggregator.cc ns-3.35/src/wifi/model/msdu-aggregator.cc
--- ns-3.34/src/wifi/model/msdu-aggregator.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/msdu-aggregator.cc	2021-10-01 13:26:48.000000000 -0700
@@ -84,14 +84,13 @@
 
 Ptr<WifiMacQueueItem>
 MsduAggregator::GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                              Time availableTime, WifiMacQueueItem::QueueIteratorPair& queueIt) const
+                              Time availableTime, WifiMacQueueItem::ConstIterator& queueIt) const
 {
   NS_LOG_FUNCTION (this << *peekedItem << &txParams << availableTime);
 
-  NS_ASSERT (peekedItem->IsQueued ());
-  NS_ASSERT (peekedItem->GetQueueIteratorPairs ().size () == 1);
-  WifiMacQueueItem::QueueIteratorPair peekedIt = peekedItem->GetQueueIteratorPairs ().front ();
-  NS_ASSERT ((*peekedIt.it)->GetPacket () == peekedItem->GetPacket ());
+  Ptr<WifiMacQueue> queue = m_mac->GetTxopQueue (peekedItem->GetQueueAc ());
+  auto it = peekedItem->GetQueueIterator ();
+  NS_ASSERT ((*it)->GetPacket () == peekedItem->GetPacket ());
 
   uint8_t tid = peekedItem->GetHeader ().GetQosTid ();
   Mac48Address recipient = peekedItem->GetHeader ().GetAddr1 ();
@@ -120,16 +119,28 @@
       return nullptr;
     }
 
-  Ptr<WifiMacQueueItem> amsdu = Copy (peekedItem);
+  Ptr<WifiMacQueueItem> amsdu = *it;  // amsdu points to the peeked MPDU, but it's non-const
   uint8_t nMsdu = 1;
 
-  peekedIt.it++;
+  it++;
 
-  while ((peekedIt.it = peekedIt.queue->PeekByTidAndAddress (tid, recipient, peekedIt.it)) != peekedIt.queue->end ()
-         && m_htFem->TryAggregateMsdu (*peekedIt.it, txParams, availableTime))
+  while ((it = queue->PeekByTidAndAddress (tid, recipient, it)) != queue->end ()
+         && m_htFem->TryAggregateMsdu (*it, txParams, availableTime))
     {
-      amsdu->Aggregate (*peekedIt.it);
-      peekedIt.it++;
+      // dequeue the MSDU being aggregated and advance the current iterator
+      // before it is invalidated
+      Ptr<WifiMacQueueItem> msdu = *it++;
+      queue->DequeueIfQueued (msdu);
+
+      auto pos = std::next (amsdu->GetQueueIterator ());
+      queue->DequeueIfQueued (amsdu);
+
+      amsdu->Aggregate (msdu);
+      bool ret = queue->Insert (pos, amsdu);
+      // The size of a WifiMacQueue is measured as number of packets. We dequeued
+      // two packets, so there is certainly room for inserting one packet
+      NS_ABORT_IF (!ret);
+
       nMsdu++;
     }
 
@@ -140,7 +151,7 @@
     }
 
   // Aggregation succeeded
-  queueIt = peekedIt;
+  queueIt = it;
 
   return amsdu;
 }
@@ -160,28 +171,7 @@
   AcIndex ac = QosUtilsMapTidToAc (tid);
 
   // Find the A-MSDU max size configured on this device
-  UintegerValue size;
-
-  switch (ac)
-    {
-      case AC_BE:
-        m_mac->GetAttribute ("BE_MaxAmsduSize", size);
-        break;
-      case AC_BK:
-        m_mac->GetAttribute ("BK_MaxAmsduSize", size);
-        break;
-      case AC_VI:
-        m_mac->GetAttribute ("VI_MaxAmsduSize", size);
-        break;
-      case AC_VO:
-        m_mac->GetAttribute ("VO_MaxAmsduSize", size);
-        break;
-      default:
-        NS_ABORT_MSG ("Unknown AC " << ac);
-        return 0;
-    }
-
-  uint16_t maxAmsduSize = size.Get ();
+  uint16_t maxAmsduSize = m_mac->GetMaxAmsduSize (ac);
 
   if (maxAmsduSize == 0)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/msdu-aggregator.h ns-3.35/src/wifi/model/msdu-aggregator.h
--- ns-3.34/src/wifi/model/msdu-aggregator.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/msdu-aggregator.h	2021-10-01 13:26:48.000000000 -0700
@@ -88,19 +88,21 @@
    * acknowledgment, as specified by the given TX parameters, does not exceed the
    * given available time (if distinct from Time::Min ())
    *
-   * If it is not possible to aggregate at least two MSDUs, no MSDU is dequeued
-   * from the EDCA queue and a null pointer is returned.
+   * If aggregation succeeds (it was possible to aggregate at least an MSDU to the
+   * given MSDU), all the aggregated MSDUs are dequeued and an MPDU containing the
+   * A-MSDU is enqueued in the queue (replacing the given MPDU) and returned.
+   * Otherwise, no MSDU is dequeued from the EDCA queue and a null pointer is returned.
    *
    * \param peekedItem the MSDU which we attempt to aggregate other MSDUs to
    * \param txParams the TX parameters for the current frame
    * \param availableTime the time available for the frame exchange
-   * \param[out] queueIt a QueueIteratorPair pointing to the queue item following the
+   * \param[out] queueIt a queue iterator pointing to the queue item following the
    *                     last item used to prepare the returned A-MSDU, if any; otherwise,
    *                     its value is unchanged
    * \return the resulting A-MSDU, if aggregation is possible, a null pointer otherwise.
    */
   Ptr<WifiMacQueueItem> GetNextAmsdu (Ptr<const WifiMacQueueItem> peekedItem, WifiTxParameters& txParams,
-                                      Time availableTime, WifiMacQueueItem::QueueIteratorPair& queueIt) const;
+                                      Time availableTime, WifiMacQueueItem::ConstIterator& queueIt) const;
 
   /**
    * Determine the maximum size for an A-MSDU of the given TID that can be sent
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/nist-error-rate-model.cc ns-3.35/src/wifi/model/nist-error-rate-model.cc
--- ns-3.34/src/wifi/model/nist-error-rate-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/nist-error-rate-model.cc	2021-10-01 13:26:48.000000000 -0700
@@ -220,11 +220,7 @@
 NistErrorRateModel::DoGetChunkSuccessRate (WifiMode mode, const WifiTxVector& txVector, double snr, uint64_t nbits, uint8_t numRxAntennas, WifiPpduField field, uint16_t staId) const
 {
   NS_LOG_FUNCTION (this << mode << snr << nbits << +numRxAntennas << field << staId);
-  if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_HT
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_VHT
-      || mode.GetModulationClass () == WIFI_MOD_CLASS_HE)
+  if (mode.GetModulationClass () >= WIFI_MOD_CLASS_ERP_OFDM)
     {
       if (mode.GetConstellationSize () == 2)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/phy-entity.cc ns-3.35/src/wifi/model/phy-entity.cc
--- ns-3.34/src/wifi/model/phy-entity.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/phy-entity.cc	2021-10-01 13:26:48.000000000 -0700
@@ -297,7 +297,7 @@
             AbortCurrentReception (status.reason);
             if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
               {
-                m_wifiPhy->MaybeCcaBusyDuration (GetMeasurementChannelWidth (ppdu));
+                m_wifiPhy->SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (ppdu));
               }
             break;
           case DROP:
@@ -359,7 +359,7 @@
 }
 
 void
-PhyEntity::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW,
+PhyEntity::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW,
                                  Time /* rxDuration */)
 {
   //The total RX power corresponds to the maximum over all the bands
@@ -383,7 +383,7 @@
       NS_LOG_DEBUG ("Cannot start RX because device is OFF");
       if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
-          m_wifiPhy->MaybeCcaBusyDuration (m_wifiPhy->GetMeasurementChannelWidth (nullptr));
+          m_wifiPhy->SwitchMaybeToCcaBusy (m_wifiPhy->GetMeasurementChannelWidth (nullptr));
         }
       return;
     }
@@ -393,7 +393,7 @@
       NS_LOG_DEBUG ("Packet reception stopped because transmitter has been switched off");
       if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
         {
-          m_wifiPhy->MaybeCcaBusyDuration (GetMeasurementChannelWidth (ppdu));
+          m_wifiPhy->SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (ppdu));
         }
       return;
     }
@@ -490,7 +490,7 @@
   if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
     {
       //that PPDU will be noise _after_ the end of the current event.
-      m_wifiPhy->MaybeCcaBusyDuration (measurementChannelWidth);
+      m_wifiPhy->SwitchMaybeToCcaBusy (measurementChannelWidth);
     }
 }
 
@@ -603,8 +603,6 @@
   Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
   WifiTxVector txVector = event->GetTxVector ();
   uint16_t staId = GetStaId (ppdu);
-  const auto & channelWidthAndBand = GetChannelWidthAndBand (event->GetTxVector (), staId);
-  double snr = m_wifiPhy->m_interference.CalculateSnr (event, channelWidthAndBand.first, txVector.GetNss (staId), channelWidthAndBand.second);
 
   std::pair<bool, SignalNoiseDbm> rxInfo = GetReceptionStatus (psdu, event, staId, relativeStart, mpduDuration);
   NS_LOG_DEBUG ("Extracted MPDU #" << mpduIndex << ": duration: " << mpduDuration.As (Time::NS) <<
@@ -615,7 +613,7 @@
   signalNoiseIt->second = rxInfo.second;
 
   RxSignalInfo rxSignalInfo;
-  rxSignalInfo.snr = snr;
+  rxSignalInfo.snr = rxInfo.second.signal / rxInfo.second.noise;
   rxSignalInfo.rssi = rxInfo.second.signal;
 
   auto statusPerMpduIt = m_statusPerMpduMap.find (std::make_pair (ppdu->GetUid (), staId));
@@ -665,7 +663,7 @@
     }
 
   DoEndReceivePayload (ppdu);
-  m_wifiPhy->MaybeCcaBusyDuration (GetMeasurementChannelWidth (ppdu));
+  m_wifiPhy->SwitchMaybeToCcaBusy (GetMeasurementChannelWidth (ppdu));
 }
 
 void
@@ -736,7 +734,7 @@
 }
 
 Ptr<Event>
-PhyEntity::DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW)
+PhyEntity::DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW)
 {
   Ptr<Event> event = CreateInterferenceEvent (ppdu, ppdu->GetTxVector (), ppdu->GetTxDuration (), rxPowersW);
 
@@ -748,13 +746,13 @@
 }
 
 Ptr<Event>
-PhyEntity::CreateInterferenceEvent (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower, bool isStartOfdmaRxing /* = false */)
+PhyEntity::CreateInterferenceEvent (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand& rxPower, bool isStartOfdmaRxing /* = false */)
 {
   return m_wifiPhy->m_interference.Add (ppdu, txVector, duration, rxPower, isStartOfdmaRxing);
 }
 
 void
-PhyEntity::UpdateInterferenceEvent (Ptr<Event> event, RxPowerWattPerChannelBand rxPower)
+PhyEntity::UpdateInterferenceEvent (Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower)
 {
   m_wifiPhy->m_interference.UpdateEvent (event, rxPower);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/phy-entity.h ns-3.35/src/wifi/model/phy-entity.h
--- ns-3.34/src/wifi/model/phy-entity.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/phy-entity.h	2021-10-01 13:26:48.000000000 -0700
@@ -358,7 +358,7 @@
    * \param rxPowersW the receive power in W per band
    * \param rxDuration the duration of the PPDU
    */
-  virtual void StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW,
+  virtual void StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW,
                                      Time rxDuration);
   /**
    * Start receiving a given field.
@@ -522,7 +522,7 @@
    * \param rxPowersW the receive power in W per band
    * \return the event holding the incoming PPDU's information
    */
-  virtual Ptr<Event> DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW);
+  virtual Ptr<Event> DoGetEvent (Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW);
   /**
    * End receiving the preamble, perform amendment-specific actions, and
    * provide the status of the reception.
@@ -717,14 +717,14 @@
    *
    * \copydoc InterferenceHelper::Add
    */
-  Ptr<Event> CreateInterferenceEvent (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower, bool isStartOfdmaRxing = false);
+  Ptr<Event> CreateInterferenceEvent (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand& rxPower, bool isStartOfdmaRxing = false);
   /**
    * Update an event in WifiPhy's InterferenceHelper class.
    * Wrapper used by child classes.
    *
    * \copydoc InterferenceHelper::UpdateEvent
    */
-  void UpdateInterferenceEvent (Ptr<Event> event, RxPowerWattPerChannelBand rxPower);
+  void UpdateInterferenceEvent (Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower);
   /**
    * Notify WifiPhy's InterferenceHelper of the end of the reception,
    * clear maps and end of MPDU event, and eventually reset WifiPhy.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/qos-frame-exchange-manager.cc ns-3.35/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.34/src/wifi/model/qos-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/qos-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
@@ -47,6 +47,12 @@
                    BooleanValue (true),
                    MakeBooleanAccessor (&QosFrameExchangeManager::m_pifsRecovery),
                    MakeBooleanChecker ())
+    .AddAttribute ("SetQueueSize",
+                   "Whether to set the Queue Size subfield of the QoS Control field "
+                   "of QoS data frames sent by non-AP stations",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&QosFrameExchangeManager::m_setQosQueueSize),
+                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -271,7 +277,7 @@
   WifiTxParameters txParams;
   txParams.m_txVector = m_mac->GetWifiRemoteStationManager ()->GetDataTxVector (mpdu->GetHeader ());
 
-  WifiMacQueueItem::QueueIteratorPair queueIt;
+  WifiMacQueueItem::ConstIterator queueIt;
   Ptr<WifiMacQueueItem> item = edca->GetNextMpdu (mpdu, txParams, availableTime, initialFrame, queueIt);
 
   if (item == nullptr)
@@ -511,6 +517,23 @@
 }
 
 void
+QosFrameExchangeManager::ForwardMpduDown (Ptr<WifiMacQueueItem> mpdu, WifiTxVector& txVector)
+{
+  NS_LOG_FUNCTION (this << *mpdu << txVector);
+
+  WifiMacHeader& hdr = mpdu->GetHeader ();
+
+  if (hdr.IsQosData () && m_mac->GetTypeOfStation () == STA
+      && (m_setQosQueueSize || hdr.IsQosEosp ()))
+    {
+      uint8_t tid = hdr.GetQosTid ();
+      hdr.SetQosEosp ();
+      hdr.SetQosQueueSize (m_mac->GetQosTxop (tid)->GetQosQueueSize (tid, hdr.GetAddr1 ()));
+    }
+  FrameExchangeManager::ForwardMpduDown (mpdu, txVector);
+}
+
+void
 QosFrameExchangeManager::TransmissionSucceeded (void)
 {
   NS_LOG_DEBUG (this);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/wifi/model/qos-frame-exchange-manager.h ns-3.35/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.34/src/wifi/model/qos-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/wifi/model/qos-frame-exchange-manager.h	2021-10-01 13:26:48.000000000 -0700
@@ -105,6 +105,7 @@
                                Time response) const override;
   void TransmissionSucceeded (void) override;
   void TransmissionFailed (void) override;
+  void ForwardMpduDown (Ptr<WifiMacQueueItem> mpdu, WifiTxVector& txVector) override;
 
   /**
    * Request the FrameExchangeManager to start a frame exchange sequence.
@@ -157,6 +158,8 @@
 
   Ptr<QosTxop> m_edca;                       //!< the EDCAF that gained channel access
   Mac48Address m_txopHolder;                 //!< MAC address of the TXOP holder
+  bool m_setQosQueueSize;                    /**< whether to set the Queue Size subfield of the
+                                                  QoS Control field of QoS data frames */
 
 private:
 
